#include <Arduino.h>
#include <AFMotor.h>


#define trigPin 17 //Arduino pin tied to trigger pin on the ultrasonic sensor
#define echoPin 18// Arduino tied to echo pin on the ultrasonic sensor
#define disablerpin 15  //to disengage the break
#define ground 14 //to disengage the break
#define buzzerpin 19 //for alert system
AF_DCMotor motor1(1);
AF_DCMotor motor2(2);
AF_DCMotor motor3(3);
AF_DCMotor motor4(4);
int distance;
long duration;
int flag=1;
long disabler;
void setup() 
{
    Serial.begin(115200);
    motor1.setSpeed(255);
    motor2.setSpeed(255);
    motor3.setSpeed(255);
    motor4.setSpeed(255);
    Serial.begin(9600);
    pinMode(trigPin, OUTPUT);
    pinMode(buzzerpin, OUTPUT);
    pinMode(echoPin, INPUT);
    pinMode(disablerpin, INPUT);
    pinMode(ground, OUTPUT);
    digitalWrite(ground, LOW);
}

void loop(void) 
{
  disabler=digitalRead(disablerpin);
  delay(100);
  Serial.print("disabler:");
  Serial.print(disabler);
  Serial.print("\n");
  Serial.print("Flag:");
  Serial.print(flag);
  Serial.print("\n");
  if (disabler <1)
  {
  distance=peg();

  if((distance=-1)&&(flag==0))
  {
      motor1.run(BACKWARD);
      motor2.run(BACKWARD);
      motor3.run(BACKWARD);
      motor4.run(BACKWARD);
      delay(1000);
      motor1.run(RELEASE);
      motor2.run(RELEASE);
      motor3.run(RELEASE);
      motor4.run(RELEASE);
      flag=1;
      Serial.print("brake Disengaged \n");
  }
   else if((distance >20) &&(flag==1))
  {
      motor1.run(FORWARD);
      motor2.run(FORWARD);
      motor3.run(FORWARD);
      motor4.run(FORWARD);
      delay(1030);
      motor1.run(RELEASE);
      motor2.run(RELEASE);
      motor3.run(RELEASE);
      motor4.run(RELEASE);
      int i=0;
      do
        {
          digitalWrite(buzzerpin,HIGH);
          delay(50);
          digitalWrite(buzzerpin,LOW);
          delay(50);
          i++;
        } while (i<3);
      flag=0;
      Serial.print("brake Engaged \n");
  }

}
else 
  {
    do
    {
    if(flag==0)
    {
      
      motor1.run(BACKWARD);
      motor2.run(BACKWARD);
      motor3.run(BACKWARD);
      motor4.run(BACKWARD);
      delay(1000);
      motor1.run(RELEASE);
      motor2.run(RELEASE);
      motor3.run(RELEASE);
      motor4.run(RELEASE);
      flag=1;
      Serial.print("brakes ddd \n");
    }
    } while(digitalRead(disablerpin)==1);
    Serial.print("brakes disabled\n");
  }
  
}
int peg(void)
{
  int distanceA=0, distanceB=0, distanceC=0, distance=0;
  int cnt=0;
    digitalWrite(trigPin, LOW); 
    delayMicroseconds(2); 
    digitalWrite(trigPin, HIGH);
    delayMicroseconds(10); 
    digitalWrite(trigPin, LOW);
    duration = pulseIn(echoPin, HIGH);
    distanceA = distance + duration/58.2;
     if ((distanceA<=35)&&(flag==1))
    {
      distance= distance +distanceA;
      cnt++;
    }
    if(((distanceA>35)&&(flag==0)))
    {
      distance= distance +distanceA;
      cnt++; 
    }
    delay(50);
    digitalWrite(trigPin, LOW); 
    delayMicroseconds(2); 
    digitalWrite(trigPin, HIGH);
    delayMicroseconds(10); 
    digitalWrite(trigPin, LOW);
    duration = pulseIn(echoPin, HIGH);
    distanceB = duration/58.2;
    if ((distanceB<=35)&&(flag==1))
    {
      distance= distance +distanceB;
      cnt++;
    }
    if(((distanceB>35)&&(flag==0)))
    {
      distance= distance +distanceB;
      cnt++; 
    }
    delay(50);
        digitalWrite(trigPin, LOW); 
    delayMicroseconds(2); 
    digitalWrite(trigPin, HIGH);
    delayMicroseconds(10); 
    digitalWrite(trigPin, LOW);
    duration = pulseIn(echoPin, HIGH);
    distanceC = duration/58.2;
    if ((distanceC<=35)&&(flag==1))
    {
      distance= distance +distanceC;
      cnt++;
    }
    if(((distanceC>35)&&(flag==0)))
    {
      distance= distance +distanceC;
      cnt++; 
    }
    distance= distance/cnt;
    if(distance>500)
    {
      distance=50;
    }
      Serial.print("distance:");
  Serial.print(distance);
  Serial.print("\n");
 return distance;
}
